/**
  Calcula la raíz cuadrada
  usando el método de Newton Rapson
**/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double raiz_cuadrada( double x )
{
	double intento=1.0;
	double v;
	int i=0;

	while( 1 ) {
		i++;
		v = fabs( intento*intento - x );
		if( v < 1e-6 )
			break;
		intento = (x/intento + intento)/2.0;
	};
	fprintf( stderr, "Hice %d pasos\n", i ); 
	return intento;
}

int main( int argc, char *argv[] )
{
	double x, r;

	if( argc != 2 ) {
		fprintf( stderr, "Args: valor_x\n" );
		return -1;
	}
	x = strtod( argv[1], NULL );

	r = raiz_cuadrada( x );
	printf( "%lf\n", r );

	return 0;
}
